function [output_image]  = free_viewpoint(image1, image2, p)
%-This function generates an image from a virtual viewpoint between two
%-real images. The output image has the same size as the input images.
addpath('Stereo Rectification');
addpath('Disparity And New View');


%% Part1: Rectification
% Tips: 
%-Inputs: Image1 and image2 must be full file name! (such as 'R1.JPG')
%-Outputs: Irect1 and Irect2 are rectified color images.
%          set: image set number.  
[Irect1,Irect2,set]= rectification(image1, image2);

%% Part2: Disparity Map Calculation
% Tips:
%-Inputs: Irect1 and Irect 2 construct a rectified stereo pair
%         set: image set number.
%-Outputs: dispL and dispR are output disparity maps
[dispL,dispR] = EstimateDispatity(Irect1, Irect2,set);

%% Part3: Generation of the virtual view
% Tips:
%-Inputs: disparity maps(dispL,dispR), camera position(p),
%         stereo pair(Irect1, Irect2)and image set number(set).
%-Outputs: output_image (image generated by the intermediate camera).
[output_image] = get_newview(dispL,dispR,Irect1,Irect2,set,p);
output_image = imresize(output_image,[2000 3000]);
end

